/******************************************
 * Anaglyph                               *
 * Tutor: Paolo Pasteris                  *
 * Progetto Multimediale 12/13 Unimi      *
 ******************************************/

PImage r,l,anaglyph;
boolean gray;
int scaleImage,renderFlag,dimension;

void setup() {
  //Convert colored image in gray scale
  gray=false;
  //gray=true;
  
  //Es 1
  r = loadImage("r.JPG");
  l = loadImage("l.JPG");
  scaleImage=6;
  renderFlag=0;
  dimension=3;
  
  //Es 2
  /*r = loadImage("robot_r.JPG");
  l = loadImage("robot_l.JPG");
  scaleImage=2;
  renderFlag=1;
  dimension=3;*/
    
  //Es 3  
  /*r = loadImage("l1.jpg");
  l = loadImage("r1.jpg");
  scaleImage=1;
  renderFlag=2;
  //renderFlag=3;
  dimension=1;*/
  
  
  
  r.resize(r.width/scaleImage,r.height/scaleImage);
  l.resize(r.width,r.height);
  size(r.width*dimension,r.height);
   
  noLoop();
}

void draw() {
  switch(renderFlag){
  case 0:
    image(elaborateL(r,l,gray,1), 0, 0);
    image(elaborateR(r,l,gray,1), r.width, 0);
    image(blendAnaglyph_RedBlue(r,l,gray), r.width*2, 0);
  break;
  case 1:
    image(elaborateL(r,l,gray,0), 0, 0);
    image(elaborateR(r,l,gray,0), r.width, 0);
    image(blendAnaglyph_RedCyan(r,l,gray), r.width*2, 0);
  break;
  case 2:
    image(blendAnaglyph_RedBlue(r,l,gray),0,0);
  break;
  case 3:
    image(blendAnaglyph_RedCyan(r,l,gray),0,0);
  break;
  }
}

PImage elaborateR(PImage right,PImage left,boolean gray,int type){
  PImage out= createImage(right.width,right.height,RGB);
  
  float r,g,b;
  if(gray){
    right.filter(GRAY);
  }

  right.loadPixels();
  left.loadPixels();
  out.loadPixels();
  switch(type){
  case 0:
    for(int i=0;i<(right.width*right.height);i++){
      r=red(right.pixels[i]);
      g=255;
      b=255;
      out.pixels[i] = color(r,g,b);
    }
  break;
  case 1:
    for(int i=0;i<(right.width*right.height);i++){
      r=red(right.pixels[i]);
      g=(green(right.pixels[i])+green(left.pixels[i]))/2;
      b=255;
      out.pixels[i] = color(r,g,b);
    }
  break;
  }
    
  out.updatePixels();
  return out;
}
PImage elaborateL(PImage right,PImage left,boolean gray,int type){
  PImage out= createImage(left.width,left.height,RGB);
  float r,g,b;
  if(gray){
    left.filter(GRAY);
  }
  left.loadPixels();
  out.loadPixels();
  switch(type){
  case 0:
    for(int i=0;i<(left.width*left.height);i++){
      r=255;
      g=green(left.pixels[i]);
      b=blue(left.pixels[i]);
      out.pixels[i] = color(r,g,b);
    }
  break;
  case 1:
    for(int i=0;i<(left.width*left.height);i++){
      r=255;
      g=(green(right.pixels[i])+green(left.pixels[i]))/2;
      b=blue(left.pixels[i]);
      out.pixels[i] = color(r,g,b);
    }
  break;
  }
  
  out.updatePixels();
  return out;
}
PImage blendAnaglyph_RedCyan(PImage right,PImage left,boolean gray){
  /*
  * Rfinal=Rleft;
  * Gfinal=Gright;
  * Bfinal=Bright;
  */
  PImage out= createImage(right.width,right.height,RGB);
  
  float r,g,b;
  if(gray){
    right.filter(GRAY);
    left.filter(GRAY);
  }
  
  right.loadPixels();
  left.loadPixels();
  out.loadPixels();
  
  for(int i=0;i<(left.width*left.height);i++){
    r=red(left.pixels[i]);
    g=green(right.pixels[i]);
    b=blue(right.pixels[i]);
    out.pixels[i] = color(r,g,b);
  }
  out.updatePixels();
  return out;
}
PImage blendAnaglyph_RedBlue(PImage right,PImage left,boolean gray){
  /*
  * Rfinal=Rleft;
  * Gfinal=(Gleft+Gright)/2;
  * Bfinal=Bright;
  */
  
  PImage out= createImage(right.width,right.height,RGB);
  
  float r,g,b;
  if(gray){
    right.filter(GRAY);
    left.filter(GRAY);
  }
  
  right.loadPixels();
  left.loadPixels();
  out.loadPixels();
  
  for(int i=0;i<(left.width*left.height);i++){
    r=red(left.pixels[i]);
    g=(green(left.pixels[i])+green(right.pixels[i]))/2;
    b=blue(right.pixels[i]);
    out.pixels[i] = color(r,g,b);
  }
  out.updatePixels();
  return out;
}
