/******************************************
 * De chirico 3d                          *
 * Tutor: Paolo Pasteris                  *
 * Progetto Multimediale 12/13 Unimi      *
 ******************************************/

import codeanticode.gsvideo.*;
import java.awt.Color;

GSCapture cam;
PImage back, front;
int factor;
void setup() 
{
   size(320, 240);
   back= loadImage("back.jpg");
   front= loadImage("front.png");
   factor=0;
}
void draw() 
{
  image(layerAnaglyph(back,factor*5),0,0);
  image(layerAnaglyph(front,factor),0,0);     
}

PImage layerAnaglyph(PImage l,int factor){
  PImage r = createImage(l.width,l.height,ARGB);
  r.copy(l,0,0,l.width,l.height,factor,0,l.width,l.height);
  return blendAnaglyph_RedCyan(r,l,false);	
}

PImage blendAnaglyph_RedCyan(PImage right,PImage left,boolean gray){
  /*
  * Rfinal=Rleft;
  * Gfinal=Gright;
  * Bfinal=Bright;
  */
  PImage out= createImage(right.width,right.height,ARGB);
  
  float r,g,b;
  if(gray){
    right.filter(GRAY);
    left.filter(GRAY);
  }
  
  right.loadPixels();
  left.loadPixels();
  out.loadPixels();
  
  for(int i=0;i<(left.width*left.height);i++){
    r=red(left.pixels[i]);
    g=green(right.pixels[i]);
    b=blue(right.pixels[i]);
    
    out.pixels[i] = color(r,g,b,max(alpha(left.pixels[i]),alpha(right.pixels[i])));
  }
  out.updatePixels();
  return out;
}
void keyPressed() {
  if (key == CODED) {
    if (keyCode == RIGHT && factor < 5) {
      factor++;
      return;
    }
    if (keyCode == LEFT && factor>0) {
      factor--;
      return;
    } 
  }
}
